<script setup>

import { computed, onMounted, onUnmounted, ref } from 'vue';

const props = defineProps({
    color: {
        type: String,
        default: 'purple',
    },
    disabled: {
        type: Boolean,
        default: false,
    },
    fixedSize: {
        type: Boolean,
        default: true,
    },
    width: {
        type: String,
        default: '',
    },
    switch: {
        type: String,
        default: '',
    },
    off: {
        type: Boolean,
        default: false,
    },
    hover: {
        type: Boolean,
        default: true,
    },
});

const colorClasses = computed(() => {    

    //if (props.disabled === false) {

        if (props.color === 'purple' && props.disabled === false && props.off === false) {
            return 'button-purple';
        }else if(props.color === 'purple' && props.off === true){
            return 'button-purple-off';
        }

        if (props.color === 'red' && props.disabled === false && props.off === false) {
            return 'button-red';
        }else if(props.color === 'red' && props.off === true){
            return 'button-red-off';
        }

        if (props.color === 'blue' && props.disabled === false && props.off === false) {
            return 'button-blue';
        }else if(props.color === 'blue' && props.off === true){
            return 'button-blue-off';
        }

    /*}else if (props.disabled === true) {

        if (props.color === 'purple') {
            return 'button-purple-off';
        }

        if (props.color === 'red') {
            return 'button-red-off';
        }

        if (props.color === 'blue') {
            return 'button-blue-off';
        }

    }*/

});

const widthClasses = computed(() => {
    if(props.width.includes("rem") || props.width.includes("px")){
        return 'w-[' + props.width + ']';
    }else if(props.width != ''){
        return 'w-' + props.width;
    }

});

const disabledClasses = computed(() => {
    if (props.disabled === true) {
        return 'button-disabled';
    }

    return '';
});

const fixedSizeClasses = computed(() => {
    if (props.fixedSize === true) {
        return 'button-consistent-size';
    }

    return '';
});

const switchClasses = computed(() => {
    if (props.switch === 'right') {
        return 'button-switch-r';
    }

    if (props.switch === 'left') {
        return 'button-switch-l';
    }

    return '';
});

const hoverClasses = computed(() => {
    if (props.hover === false) {
        return 'button-hover-disabled';
    }

    return '';
});
</script>

<template>

    <button type="button" :class="[colorClasses, disabledClasses, fixedSizeClasses, switchClasses, widthClasses, hoverClasses]" class="default-button">
        <slot />
    </button>

</template>